Subject: Re: When should we release Git 3.0?

From: Luca Milanesio <[email-masked]>
Date: Wed, 1 Oct 2025 08:13:12 +0100

> On 1 Oct 2025, at 00:07, brian m. carlson <[email-masked]> wrote:
> 
> There's been discussion at the Contributor Summit about when we should
> release Git 3.0.  The original plan that was discussed was to release in
> about a year, which is about 4 releases away.
> 
> Almost all of the functionality that we had wanted in Git 3.0 has been
> implemented.  The two major things we may want to consider as blockers
> for Git 3.0 are the following:
> 
> * The SHA-256 interoperability work is not done yet.  My estimate of
>  this work is 200–400 patches, of which about 100 are done.  If the
>  original schedule is maintained, this would require writing up to 75
>  patches and sending in 100 patches per cycle, which is unrealistic
>  without additional contributors.
> * Some forges and other projects do not yet have full SHA-256 support.
>  It's my understanding that all of the major forges are undertaking or
>  have undertaken this work and are at various levels of completion, but
>  it's not clear that other projects have appropriate support.
> 
> We may also wish to stick to a stricter timeframe for this release
> regardless and make four releases from now or the next release a year
> away Git 3.0 regardless of whether those items above are completed.

I apologise to not have participated to the Contributor Summit, I just joined the Git Mini-Summit in Amsterdam and we discussed briefly Gerrit 3.0 over dinner, but not with such a detail.
Do you have the notes or recording of the discussion?

I am worried that if we rush into Git 3.0 with breaking changes that would make other “forges” (e.g. JGit) incompatible, we would be in a difficult situation with the other Git ecosystem that isn’t based on the C-Git implementation.

> Discussions at the Contributor Summit did mention the advantage of
> having a hard deadline would be that it would make projects and forges
> spend the time to implement SHA-256 support if they're lacking it.

Happy to spend more time on it, I believe Nasser and Martin from the JGit project attended in-person yesterday.
Any commitment from your side? Do you have budget from your $DAY_JOB?

> I personally do not want the interoperability work to be a blocker.  I
> haven't really heard other commitments of contributors who want to work
> on it and I don't really want to have to run full tilt trying to get it
> out.  However, some other people may feel differently, in which I case I
> encourage their participation in the project.

Sure, happy to participate.

Luca.